import network
import urequests
import time
import json
from machine import Pin
import os
import socket
import dht

# Konfiguracja WiFi
SSID = "iPhone"
PASSWORD = "kuba12344"

# Adres serwera proxy
PROXY_URL = "http://172.20.10.11:5000/api/chat"

# Funkcje LED

def connect_wifi():
    """Łączenie z siecią WiFi"""
    wlan = network.WLAN(network.STA_IF)
    wlan.active(True)
    if not wlan.isconnected():
        print("Łączenie z WiFi...")
        wlan.connect(SSID, PASSWORD)
        while not wlan.isconnected():
            time.sleep(1)
    print("Połączono z WiFi:", wlan.ifconfig())

def send_prompt_to_gpt(prompt):
    """Wysyła prompt do serwera proxy i zwraca odpowiedź"""
    try:
        headers = {"Content-Type": "application/json"}
        payload = json.dumps({"prompt": prompt})
        response = urequests.post(PROXY_URL, data=payload, headers=headers)
        if response.status_code == 200:
            data = response.json()
            print("Odpowiedź GPT:", data)
            response.close()
            return data
        else:
            print("Błąd serwera proxy:", response.status_code, response.text)
            response.close()
    except Exception as e:
        print("Błąd połączenia:", str(e))

def save_to_file(prompt, response):
    """Zapisuje prompt i odpowiedź do pliku"""
    try:
        with open("gpt_responses.txt", "a") as file:
            file.write(f"Prompt: {prompt}\n")
            file.write(f"Response: {response}\n")
            file.write("-" * 40 + "\n")
        print("Zapisano do pliku.")
    except Exception as e:
        print("Błąd zapisu do pliku:", str(e))

def execute_generated_code(code):
    """Wykonuje wygenerowany kod"""
    try:
        exec(code)
    except Exception as e:
        print("Błąd w wykonaniu kodu:", str(e))

def start_file_server():
    """Uruchamia serwer plików HTTP"""
    addr = socket.getaddrinfo('0.0.0.0', 8080)[0][-1]
    s = socket.socket()
    s.bind(addr)
    s.listen(1)

    print('Serwer działa na http://0.0.0.0:8080')
    while True:
        cl, addr = s.accept()
        print('Połączenie od', addr)
        request = cl.recv(1024)
        request = str(request)

        # Pobierz plik
        file_path = "gpt_responses.txt"
        if os.path.exists(file_path):
            with open(file_path, 'r') as file:
                content = file.read()
            response = 'HTTP/1.0 200 OK\r\nContent-Type: text/plain\r\n\r\n' + content
        else:
            response = 'HTTP/1.0 404 Not Found\r\nContent-Type: text/plain\r\n\r\nFile not found'

        cl.send(response)
        cl.close()

def main():
    connect_wifi()

    while True:
        # Pobierz prompt od użytkownika
        prompt = input("Podaj prompt dla GPT: ")
        if prompt.lower() == "exit":
            print("Kończę program.")
            break

        # Wyślij prompt do proxy
        response = send_prompt_to_gpt(prompt)
        if response and "code" in response:
            response_code = response["code"]
            print("Kod wygenerowany przez GPT:")
            print(response_code)
            save_to_file(prompt, response_code)
            print("Wykonywanie kodu na ESP...")
            execute_generated_code(response_code)
        else:
            print("Brak kodu w odpowiedzi lub nieprawidłowa odpowiedź.")

# Uruchom serwer plików w osobnym wątku (opcjonalne)
try:
    _thread.start_new_thread(start_file_server, ())
except Exception as e:
    print("Nie można uruchomić serwera plików:", str(e))

if __name__ == "__main__":
    main()
