from flask import Flask, request, jsonify
import requests

app = Flask(__name__)

# Twój klucz API do OpenAI
API_KEY = "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"

# URL API OpenAI
OPENAI_API_URL = "https://api.openai.com/v1/chat/completions"

@app.route('/api/chat', methods=['POST'])
def chat_proxy():
    # Pobierz dane od ESP8266
    data = request.get_json()

    if not data or "prompt" not in data:
        return jsonify({"error": "Brak prompt w żądaniu."}), 400

    prompt = data["prompt"]

    # Przygotuj payload do API OpenAI
    headers = {
        "Authorization": f"Bearer {API_KEY}",
        "Content-Type": "application/json"
    }

    payload = {
        "model": "gpt-3.5-turbo",
        "messages": [
            {"role": "system", "content": "This is a main information but usefull informations: You are a helpful assistant that generates clean Python code for ESP8266. You have red diodes on GPIO04 and GPIO12 moreover on GPIO14 and GPIO00 you have green diodes. Also you have temperature sensor DHT11 with out to GPIO 05. GPIO15 you have out for LED strip use neopixel, moreover if there is a decision to use led strip here is easy working code which you have to upgrade: LED_STRIP_PIN = 15;NUM_PIXELS = 8;pin = machine.Pin(LED_STRIP_PIN, machine.Pin.OUT);np = neopixel.NeoPixel(pin, NUM_PIXELS);np[0] = (255, 255, 255);np.write() but you need to delete ; and code normally, there is a leds from 0 to 8.Print only python code nothing more, just the code."},
            {"role": "user", "content": prompt}
        ]
    }

    try:
        # Wykonaj żądanie do API OpenAI
        response = requests.post(OPENAI_API_URL, headers=headers, json=payload)
        response.raise_for_status()

        # Wyodrębnij kod z odpowiedzi i usuń formatowanie Markdown
        response_json = response.json()
        raw_content = response_json.get("choices", [{}])[0].get("message", {}).get("content", "Brak wygenerowanego kodu.")

        # Usuń znaki Markdown (```python i ```)
        if raw_content.startswith("```python") and raw_content.endswith("```"):
            cleaned_code = raw_content[9:-3].strip()
        else:
            cleaned_code = raw_content.strip()

        # Zwrot odpowiedzi w formacie JSON z kluczami dla ESP8266
        return jsonify({"code": cleaned_code})
    except requests.exceptions.RequestException as e:
        return jsonify({"error": str(e)}), 500

if __name__ == '__main__':
    app.run(host='0.0.0.0', port=5000)
